栏目分类:
子分类:
返回
名师互学网用户登录
快速导航关闭
当前搜索
当前分类
子分类
实用工具
热门搜索
名师互学网 > IT > 软件开发 > 后端开发 > C/C++/C#

LeetCode 1824. 最少侧跳次数**

C/C++/C# 更新时间: 发布时间: IT归档 最新发布 模块sitemap 名妆网 法律咨询 聚返吧 英语巴士网 伯小乐 网商动力

LeetCode 1824. 最少侧跳次数**

具体思想:

卡在了dp条件上,其实思路不难想;

里面有一个坑,有两种情况:

  1. 该点当前有障碍,所以应该设置为不可达;
  2. 当前点无障碍,但是必须要要从上一个无障碍的地方跳过来;

所以判断特别繁琐,简单的判定方式为:

  1. 先判断当前是否有障碍,无障碍就直接从上一个地方跳过来;
  2. 在判断是否可以从同级的其他地方跳过来;

这样判断有一好处,第一个条件可以保证跳过来的点,在同一级中同水平必须可达,破除坑1,并且可以同时满足2,判断三个最小值;

例如:

1 o
o
1

第一列第二个位置不可达,要求补充第二列;

  1. 先判断当前是否有障碍,无障碍就直接从上一个地方跳过来;
    可以得到:
    1 o
    o o
    1 1
    第二列中,第一个位置不可达,第二个位置从上一个位置不可达,第三个可以从上一个位置可达;

  2. 在判断是否可以从同级的其他地方跳过来;
    可以得到:
    1 o
    o 2
    1 1
    第二个位置可以由3可达,因为第一行并不可达;

所以相当于取了与操作;

具体代码:
class Solution {
public:
    int minSideJumps(vector& obstacles) {
        int n=obstacles.size();
        vector>dp(n,vector(3,INT_MAX/2));
        dp[0][0]=dp[0][2]=1;
        dp[0][1]=0;
        if(n==1)
            return 0;
        for(int i=1;i
            int ob=obstacles[i]-1;
            for(int j=0;j<3;j++){
                if(j!=ob){
                    dp[i][j]=dp[i-1][j];
                }
            }
            for(int j=0;j<3;j++){
                if(ob==j){
                    //如果该处是障碍物;
                    //dp[i][j]=INT_MAX/2;
                    continue;
                }
                dp[i][j]=min(dp[i][j],min(dp[i][(j+1)%3],dp[i][(j+2)%3])+1);
            }
        }
        return min(dp[n-1][0],min(dp[n-1][1],dp[n-1][2]));
    }
};
转载请注明:文章转载自 www.mshxw.com
本文地址:https://www.mshxw.com/it/955042.html
我们一直用心在做
关于我们 文章归档 网站地图 联系我们

版权所有 (c)2021-2022 MSHXW.COM

ICP备案号:晋ICP备2021003244-6号